; #########################################################################

  ; --------------------------------------------------
  ; This procedure was written by Raymond Filiatreault
  ; --------------------------------------------------

    .386
    .model flat, stdcall  ; 32 bit memory model
    option casemap :none  ; case sensitive

      include \masm32\include\Mix.inc

    .code

; #########################################################################

MixToInt proc public MInt:DWORD
        
    ; -------------------------------------------------------------
    ; Converts from a Mixed Integer format to a signed 32-bit integer 
    ; after rounding.
    ;
    ; MInt: A Mixed Integer DWORD
    ; 
    ; EXAMPLE:
    ;
    ;       invoke MixToInt, var
    ;
    ; The result is returned in eax. If the value of the parameter
    ; is 80000000h (i.e. -0), that value is returned unchanged.
    ;
    ; -------------------------------------------------------------

    mov eax,MInt

    cmp eax,ERROR
    jnz @F
    ret

  @@:
    or  eax,eax
    jns positive
    neg eax
    shr eax,16
    jnc  @F
    .if eax != 7fffffffh
        inc eax
    .endif
  @@:
    neg eax
    ret

positive:
    shr eax,16
    jnc @F
    .if eax != 7fffffffh
        inc eax
    .endif
  @@:
    ret

MixToInt endp

; #########################################################################

end
