;#############################################
;
;     data and mundane subroutines for Mixtest
;
;#############################################

    ;=============
    ; Local macros
    ;=============

    m2m MACRO M1, M2
      push M2
      pop  M1
    ENDM

    return MACRO arg
      mov eax, arg
      ret
    ENDM

    .data
    
    hInstance   dd  0
    hDlg        dd  0
    hBuf        dd  0
    hOpen       dd  0

    param1adds  dd  param1txt1,param1txt1,param1txt1,param1txt1,param1txt1,param1txt1
                dd  param1txt2,param1txt2,param1txt3,param1txt3,param1txt4,param1txt4
                dd  param1txt5,param1txt5,param1txtB,param1txtB,param1txt5,param1txt5
                dd  param1txt3,param1txt4,param1txt6,param1txt7,param1txt2,param1txt3
                dd  param1txt8,param1txt9,param1txtA

    functionx   dd  sinx,cosx,tanx,cotx,secx,cscx
                dd  asinx,acosx,atanx,acotx,asecx,acscx
                dd  sinhx,coshx,tanhx,cothx,sechx,cschx
                dd  asinhx,acoshx,atanhx,acothx,asechx,acschx
                dd  lnx,expx,sqrtx

    func1adds   dd  xsin,xcos,xtan,xcot,xsec,xcsc
                dd  xasin,xacos,xatan,xacot,xasec,xacsc
                dd  xsinh,xcosh,xtanh,xcoth,xsech,xcsch
                dd  xasinh,xacosh,xatanh,xacoth,xasech,xacsch
                dd  xln,xexp,xsqrt

    func2adds   dd  xasin,xacos,xatan,xacot,xasec,xacsc
                dd  xsin,xcos,xtan,xcot,xsec,xcsc
                dd  xasinh,xacosh,xatanh,xacoth,xasech,xacsch
                dd  xsinh,xcosh,xtanh,xcoth,xsech,xcsch
                dd  xexp,xln,xsqr

    doubled     dq  0

    bufsize     dd  0
    available   dd  0
    editsize    dd  0
    maxbuf      dd  0
    
    flop        OPENFILENAME <>

    fselected   dd  0
    param1      dd  0
    param2      dd  0
    c32k        dd  32768
    c64k        dd  65536
    expon       dd  0
    fpuresult   dd  0
    mixresultA  dd  0
    mixresultB  dd  0
    quadrantx   dd  0
    filsize     dd  0

    cword       dw  0
    w180        dw  180
    
    inbuf       db  64 dup(0)

    inputA      db  16 dup(0)
    inputB      db  16 dup(0)

    outbuf1     db  "FPU  "
    outbuf1a    db  25 dup(0)
    outbuf1b    db  13 dup(0),13,10
    outbuf2     db  "Mix  "
    outbuf2a    db  25 dup(0)
    outbuf2b    db  13 dup(0),13,10
    outbuf3     db  "Mix  "
    outbuf3a    db  25 dup(0)
    outbuf3b    db  13 dup(0),13,10,13,10,0
    
    param1err   db  "Error in 1st parameter",0
    param2err   db  "Error in 2nd parameter",0
    param1txt1  db  "Angle in degrees",0
    param1txt2  db  "-1.0 to +1.0",0
    param1txt3  db  "-32767.0 to +32767.0",0
    param1txt4  db  "+/-1.0 to +/-32767.0",0
    param1txt5  db  "-11.09033 to +11.09033",0
    param1txt6  db  "-0.99999 to +0.99999",0
    param1txt7  db  "+/-1.00001 to +/-32767.0",0
    param1txt8  db  "0.00001 to +32767.0",0
    param1txt9  db  "-10.39717 to +10.39717",0
    param1txtA  db  "0 to +32767.0",0
    param1txtB  db  "-5.0 to +5.0",0
    param2txt1  db  "+1  or -1"
    nulltxt     db  0

    xsin        db  "sin(",0
    xcos        db  "cos(",0
    xtan        db  "tan(",0
    xcot        db  "cotan(",0
    xsec        db  "sec(",0
    xcsc        db  "cosec(",0
    xasin       db  "asin(",0
    xacos       db  "acos(",0
    xatan       db  "atan(",0
    xacot       db  "acotan(",0
    xasec       db  "asec(",0
    xacsc       db  "acosec(",0
    xsinh       db  "sinh(",0
    xcosh       db  "cosh(",0
    xtanh       db  "tanh(",0
    xcoth       db  "cotanh(",0
    xsech       db  "sech(",0
    xcsch       db  "cosech(",0
    xasinh      db  "asinh(",0
    xacosh      db  "acosh(",0
    xatanh      db  "atanh(",0
    xacoth      db  "acotanh(",0
    xasech      db  "asech(",0
    xacsch      db  "acosech(",0
    xln         db  "ln(",0
    xexp        db  "e^",0
    xsqrt       db  "sqrt(",0
    xsqr        db  "sqr(",0

    szexist     db  "File already exists.",0ah,0dh
                db  "Overwrite file?",0
    szfilnam    db  256 DUP(0)
    szDisplay   db  "MIXTEST",0


;#####################################################################

    .code

getparam1:
    invoke  GetDlgItemText,hDlg,765,ADDR inbuf,64
    .if     eax == 0
        mov eax,ERROR
        ret
    .endif
    invoke  MixFromA,ADDR inbuf
    mov     param1,eax
    .if     eax == ERROR
        ret
    .endif

    mov     ecx,eax
    or      ecx,ecx
    jns     @F
    neg     ecx
  @@:
    .if     fselected == 6 || fselected == 7
        .if     ecx > 1 shl 16
            jmp     getpar1err
        .endif
    .elseif fselected == 10 || fselected == 11
        .if     ecx < 1 shl 16
            jmp     getpar1err
        .endif
    .elseif fselected == 14 || fselected == 15
        .if     ecx > 5 shl 16
            jmp     getpar1err
        .endif
    .elseif fselected > 11 && fselected < 18
        .if     ecx > 0B1720h
            jmp     getpar1err
        .endif
    .elseif fselected == 19
        .if     ecx < 1 shl 16
            jmp     getpar1err
        .endif
    .elseif fselected == 20
        .if     ecx > 0FFFFh
            jmp     getpar1err
        .endif
    .elseif fselected == 21
        .if     ecx < 10001h
            jmp     getpar1err
        .endif
    .elseif fselected == 22
        .if     ecx > 1 shl 16
            jmp     getpar1err
        .endif
    .elseif fselected == 24
        or      eax,eax
        jng     getpar1err
    .elseif fselected == 25
        cmp     ecx,0A65ADh
        ja      getpar1err
    .elseif fselected == 26
        or      eax,eax
        js      getpar1err
    .endif

getpar1a:
    mov     param1,eax
    push    eax
    invoke  MixToA,eax,ADDR inputA
    pop eax
    ret

getpar1err:
    mov     eax,ERROR
    ret

;-----------------------------

getparam2:
    invoke  GetDlgItemText,hDlg,766,ADDR inbuf,64
    .if     eax == 0
        mov eax,ERROR
        ret
    .endif
    invoke  MixFromA,ADDR inbuf
    .if     eax == ERROR
        ret
    .endif
    mov     param2,eax
    or      eax,eax
    jns     @F
    neg     eax
  @@:
    cmp     eax,1 shl 16
    jnz     getpar1err
    ret

;-----------------------------

quadrant:
    mov     eax,param1
    or      eax,eax
    jns     @F
    neg     eax
  @@:
    push    eax
    shr     eax,16
    xor     edx,edx
    mov     ecx,360
    div     ecx
    shl     edx,16
    pop     eax
    shl     eax,16
    shr     eax,16
    add     eax,edx
    mov     ecx,param1
    or      ecx,ecx
    jns     @F
    neg     eax
    add     eax,360 shl 16
  @@:
    mov     param1,eax
    xor     edx,edx
    mov     ecx,90 shl 16
    div     ecx
    mov     quadrantx,eax
    ret

;-----------------------------

showres:
    push    esi
    push    edi
    
    lea     edi,outbuf1a
    mov     ax,2020h
    mov     ecx,19
    rep     stosw
    add     edi,7
    mov     ecx,19
    rep     stosw
    add     edi,7
    mov     ecx,19
    rep     stosw
    
    invoke  MixToA,param1,ADDR inputA
    invoke  MixToA,mixresultA,ADDR inputB

    invoke  MixToA,fpuresult,ADDR inbuf
    lea     edi,outbuf1b
    lea     esi,inbuf
    call    insertsz

    lea     edi,outbuf2b
    lea     esi,inputB
    call    insertsz

    invoke  MixToA,mixresultB,ADDR inbuf
    lea     edi,outbuf3b
    lea     esi,inbuf
    call    insertsz
    
    lea     edi,outbuf1a
    mov     eax,fselected
    shl     eax,2
    mov     esi,func1adds[eax]
    call    insertsz
    lea     esi,inputA
    call    insertsz
    .if     fselected != 25
        mov al,")"
        stosb
    .endif
    
    lea     esi,outbuf1a
    lea     edi,outbuf2a
    mov     ecx,25
    rep     movsb
    
    lea     edi,outbuf3a
    mov     eax,fselected
    shl     eax,2
    mov     esi,func2adds[eax]
    call    insertsz
    lea     esi,inputB
    call    insertsz
    .if     fselected != 24
        mov al,")"
        stosb
    .endif

    .if     available < 140
        invoke  LocalFree,hBuf
        mov     eax,bufsize
        add     eax,4000
        invoke  LocalAlloc,0,eax
        mov     hBuf,eax
        invoke  LocalSize,eax
        mov     bufsize,eax
        mov     available,eax
        invoke  GetDlgItemText,hDlg,780,hBuf,eax
        mov     editsize,eax
        sub     available,eax
    .endif

    mov     edi,hBuf
    add     edi,editsize
    lea     esi,outbuf1
    mov     ecx,69
    rep     movsw
    invoke  SetDlgItemText,hDlg,780,hBuf
    add     editsize,137
    sub     available,137
    invoke  SendDlgItemMessage,hDlg,780,EM_GETLINECOUNT,0,0
    sub     eax,9
    jc      @F
    invoke  SendDlgItemMessage,hDlg,780,EM_LINESCROLL,0,eax
 @@:
    pop     edi
    pop     esi
    ret

insertsz:
    lodsb
    or      al,al
    jz      @F
    stosb
    jmp     insertsz
 @@:
    ret

;-----------------------------

savedata:

    mov     flop.lStructSize, sizeof OPENFILENAME
    m2m     flop.hWndOwner,   hDlg
    m2m     flop.hInstance,   hInstance
    lea     eax,szfilnam
    mov     flop.lpstrFile,   eax
    mov     flop.nMaxFile,    255
    mov     flop.Flags,       OFN_PATHMUSTEXIST

    invoke  GetSaveFileName,ADDR flop

    invoke  CreateFile,ADDR szfilnam,GENERIC_READ or GENERIC_WRITE,
    NULL,NULL,OPEN_ALWAYS,NULL,NULL
    
    mov     hOpen,eax
    invoke  GetLastError
    .if     eax == ERROR_ALREADY_EXISTS
        invoke  MessageBox,hDlg,ADDR szexist,ADDR szDisplay,MB_YESNOCANCEL or MB_ICONQUESTION
        .if     eax == IDCANCEL || eax == IDNO
            invoke CloseHandle,hOpen
            ret
        .endif
    .endif
    
    invoke  WriteFile,hOpen,hBuf,editsize,ADDR filsize,NULL
    invoke  SetEndOfFile,hOpen
    invoke  CloseHandle,hOpen
    ret
